<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for FilterFilename.
 * Generated by PHPUnit on 2012-07-04 at 14:02:00.
 * @group directory_iterators
 */
class FilterFilenameTest extends \PHPUnit_Framework_TestCase {

    /** @var FilterFilename */
    private $filter;

    protected function setUp() {
        $this->filter = new FilterFilename();
    }

    public function testDisplayInvalidNames() {
        $this->assertDisplay('navigation', 'navig ? ation', 'setDisplayInvalidNames');
    }

    public function testDisplayFolderIndex() {
        $this->assertDisplay('navigation', TREEWEC_NAME_OF_INDEX_FILE, 'setDisplayFolderIndex');
    }

    public function testDisplayDefaultHiddenFiles() {
        $this->assertDisplay('navigation', '.htaccess', 'setDisplayDefaultHiddenFiles');        
        $this->assertDisplay('teams', '.htpasswd', 'setDisplayDefaultHiddenFiles');
        $this->assertDisplay('navigation', 'dir.order', 'setDisplayDefaultHiddenFiles');
    }

    public function testDisplayUserHiddenFiles() {
        $hiddenFilenames = explode(';', TREEWEC_USER_HIDDEN_FILES);
        foreach($hiddenFilenames as $filename) {
            $this->assertDisplay('navigation', $filename, 'setDisplayUserHiddenFiles');
        }
    }

    public function assertDisplay($validName, $invalidName, $filterSetter) {
        $validElement = new IteratorElement(1, new \SplFileInfo(TREEWEC_VIEW_DIR . $validName));
        $invalidElement = new IteratorElement(1, new \SplFileInfo(TREEWEC_VIEW_DIR . $invalidName));
        // default = false
        $this->filter->$filterSetter(false);
        parent::assertTrue($this->filter->canBeProcessed($validElement));
        parent::assertFalse($this->filter->canBeProcessed($invalidElement));

        $this->filter->$filterSetter(true);
        parent::assertTrue($this->filter->canBeProcessed($validElement));
        parent::assertTrue($this->filter->canBeProcessed($invalidElement));
    }

}

?>
